local Recount2 = Recount2

local math_fmod = math.fmod
local math_min = math.min

local BUFFER_SIZE = 64
local EVENTS_PER_FRAME = 5

local buffer = {}
local buffer_pos = 1
local buffer_length = 0

function Recount2:InitBuffer()
	for i = 1, BUFFER_SIZE do
		buffer[i] = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
	end

	self.dataInBuffer = false
end

function Recount2:AddToBuffer(timestamp, srcGUID, dstGUID, spellID, ability, info, power, school, hitType, amount, resist, absorb, block, over)
	local newPos = buffer_pos+buffer_length
	
	if newPos>BUFFER_SIZE then
		newPos = newPos - BUFFER_SIZE
	end

	local curBuffer = buffer[newPos]

	--If the buffer size is the same as the current length have to process the event first
	if buffer_length==BUFFER_SIZE then
		self:AddMainData(unpack(buffer[buffer_pos]))
		buffer_pos = buffer_pos + 1
		if buffer_pos>BUFFER_SIZE then
			buffer_pos = 1
		end
	else
		buffer_length = buffer_length + 1
	end

	curBuffer[1] = timestamp
	curBuffer[2] = srcGUID
	curBuffer[3] = dstGUID
	curBuffer[4] = spellID
	curBuffer[5] = ability
	curBuffer[6] = info
	curBuffer[7] = power
	curBuffer[8] = school
	curBuffer[9] = hitType
	curBuffer[10] = amount
	curBuffer[11] = resist
	curBuffer[12] = absorb
	curBuffer[13] = block
	curBuffer[14] = over

	
	if self.dataInBuffer == false then
		self.EventFrame:SetScript("OnUpdate", self.HandleTimers)
		self.dataInBuffer = true
	end
end

function Recount2:ProcessBuffer()
	local processNum = math_min(EVENTS_PER_FRAME, buffer_length)
	for i = 1, processNum do
		self:AddMainData(unpack(buffer[buffer_pos]))

		buffer_pos = buffer_pos + 1
		if buffer_pos>BUFFER_SIZE then
			buffer_pos = 1
		end
	end
	--Decrement buffer length
	buffer_length = buffer_length - processNum

	if buffer_length==0 then
		self.dataInBuffer = false
	end
end
